      !--------------------------------------------------------------------
      subroutine bdfl4r(l4arr,nelem1,nelem2,output,no,start,step,npix,ierr)
      !--------------------------------------------------------------------

      use dal
      use global
      use cgenl

      implicit none

!      include 'include/cgenl_f90.cmn'

      integer     maxdim,naxis,ix,iy
      parameter   (maxdim=2)
      integer npix(maxdim)
      integer     nelem1, nelem2, no, ierr
      logical, dimension(nelem1,nelem2) :: l4arr
      double precision start(maxdim),step(maxdim)
      character*(*) output

      type(datasett) :: set
      type(arrayt) :: arr
      integer, dimension(:,:), pointer :: i4arr0
      integer, dimension(:), pointer :: npixp 

      set = dataset (output, read)
      arr = array(set, "PRIMARY", read)
      i4arr0 => int32array2data(arr)
      npix(1) = 640 ! int16attribute(arr,"naxis1")
      npix(2) = 640 ! int16attribute(arr,"naxis2")
!      npixp = arraysize(arr)
!      npix = npixp 
      do ix=1,npix(1)
        do iy=1,npix(2)
          if (i4arr0(ix-1,iy-1) == 0) then
            l4arr(ix,iy) = .false.
          else
            l4arr(ix,iy) = .true.
          end if 
        end do
      end do
      start(1) = 1d0
      start(2) = 1d0
      step(1) = 1d0
      step(2) = 1d0

      call release(arr)
      call release(set)

      end subroutine bdfl4r
